<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: MocoTrack: motion tracking</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocotrack.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title"><a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a>: motion tracking </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>For some research applications in musculoskeletal biomechanics, it is not sufficient to perform a simulation where model kinematics are prescribed directly from experimental data.</p>
<p>These approaches, called 'inverse' problems, are ubiquitous and useful (see <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a>), but provide no way to explain how a change in a system parameter or optimization criteria might affect the optimal kinematics of the system. A different class of problems, called 'tracking' problems, addresses this limitation by freeing up model kinematics while adding a cost term that computes the error between experimental data and the associated model quantities. While tracking problems have been historically either difficult to pose or computationally burdensome, recent methods using direct collocation for solving tracking problems in biomechanics have proven this now to be a viable tool [1, 2].</p>
<p>In Moco, you can use the <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a> tool to solve tracking optimization problems. The <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a> tool accepts both marker trajectory and model coordinate kinematic data sets and adds a <a class="el" href="classOpenSim_1_1MocoMarkerTrackingGoal.html">MocoMarkerTrackingGoal</a> and/or <a class="el" href="classOpenSim_1_1MocoStateTrackingGoal.html">MocoStateTrackingGoal</a> term(s) accordingly. Both types of kinematic data can be tracked simultaneously and weights for each cost term can be supplied. In addition, weights can be set for individual components of tracked data sets (e.g., tracking markers on bony landmarks preferentially over markers on soft tissue).</p>
<p>Additional features provided by <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a> include: ensuring that the problem time window is consistent with all data sets, filling in missing coordinate speed states to track if only coordinate values are available, and appending tracking data to the problem initial guess.</p>
<p>Examples in the Moco distribution:</p><ul>
<li>MATLAB: <a class="el" href="exampleMocoTrack_8m-example.html">Resources/Code/Matlab/exampleMocoTrack/exampleMocoTrack.m</a></li>
<li>Python: <a class="el" href="exampleMocoTrack_8py-example.html">Resources/Code/Python/exampleMocoTrack/exampleMocoTrack.py</a></li>
<li>C++: <a class="el" href="exampleMocoTrack_8cpp-example.html">Resources/Code/CPP/exampleMocoTrack/exampleMocoTrack.cpp</a></li>
</ul>
<p>[1] Lin Y., Pandy M., 2017, Three-dimensional data-tracking dynamic optimization simulations of human locomotion generated by direct collocation. Journal of Biomechanics 59, 1-8. <br  />
[2] Nguyen V. et al., 2019, Bilevel Optimization for Cost Function Determination in Dynamic Simulation of Human Gait. IEEE Transactions on Neural Systems and Rehabilitation Engineering, DOI: 10.1109/TNSRE.2019.2922942. <br  />
</p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li><li class="navelem"><a class="el" href="mocouserguide.html">Moco User Guide</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
